unit Unit1;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShlObj, Buttons;

// 
const
  LM20_NNLEN = 12;
  SHPWLEN = 8;
  SHI50F_RDONLY = 1;
  SHI50F_FULL = 2;
  STYPE_DISKTREE = 0;

  MaxNetArrayItems=512;

//      
type
// Win'9x
  TShareInfo50 = packed record
    shi50_netname: array[0..LM20_NNLEN] of Char; // 
    shi50_type: Byte;                            // 
    shi50_flags: Short;                          // 
    shi50_remark: PChar;                         // 
    shi50_path: PChar;                           //   
    shi50_rw_password: array[0..SHPWLEN] of Char;//  
    shi50_ro_password: array[0..SHPWLEN] of Char;// " " 
  end;

TShareEvent = Record  //   
Res                 :Integer;
ReadOnlyPassword    :String;
FullAccessPassword  :String;
Comments            :String;
Path                :String;
End;



  TForm1 = class(TForm)
    edComputerNetName: TEdit;
    Button1: TButton;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    lbReadOnlyPassword: TLabel;
    edReadOnlyPassword: TEdit;
    lbFullAccessPassword: TLabel;
    edFullAccessPassword: TEdit;
    lbComments: TLabel;
    edComments: TEdit;
    lbPhysicalPath: TLabel;
    edPhysicalPath: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  Procedure FillShareEnum(Items:TStrings);
  Function GetComputerNetName:String;
  Function GetShareInfo(ComputerNetName,ResourceNetName:String):TShareEvent;
  Procedure ConnectAdmin;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
Function NetShareGetInfo(const pszServer: PChar; const pszNetName: PChar;
  sLevel: SmallInt; pbBuffer: Pointer; cbBuffer: Word;
  var pcTotalAvail: Word): DWORD; stdcall; External 'svrapi.dll' name 'NetShareGetInfo';
Function NetShareEnum(const pszServer: PChar; sLevel: SmallInt;
  pbBuffer: Pointer; cbBuffer: Word; var pcEntriesRead: Word;
  var pcTotalAvail: Word): DWORD; stdcall; external 'svrapi.dll';

implementation

{$R *.DFM}

Procedure TForm1.ConnectAdmin;
Var
CompName:String;
Res:Integer;
lpNetResource:TNetResource;
ComputerName:Array[0..MAX_COMPUTERNAME_LENGTH] Of Char;
BufSize:Integer;
Begin
//   
BufSize:=MAX_COMPUTERNAME_LENGTH + 1;
GetComputerName(@ComputerName,BufSize);
CompName:=String(ComputerName);
//        ,
//        -
//   ADMIN$  
If AnsiUpperCase(CompName)= AnsiUpperCase(edComputerNetName.Text) Then Exit;
//   
ZeroMemory(@lpNetResource,SizeOf(lpNetResource));
//  
With lpNetResource Do
Begin
dwType:=RESOURCETYPE_ANY;
lpRemoteName:='';
lpRemoteName:=PChar('\\'+edComputerNetName.Text+'\ADMIN$'+#0);
End;
//, !
Res:=WNetAddConnection3(Application.Handle,lpNetResource,Nil,Nil,CONNECT_INTERACTIVE);
//,    ...
If Not(Res= NO_ERROR) Then
Begin
ShowMessage('Without connected resource ''ADMIN$'' a work impossible!');
Application.Terminate;
End;
End;

Function TForm1.GetShareInfo(ComputerNetName,ResourceNetName:String):TShareEvent;
Var
pbBuffer:^TShareInfo50;//  
Buf:TShareInfo50;      // 
Res:Integer;
pcTotalAvail:Word;     //  
Begin
With Result Do //  
Begin
res:=0;
ReadOnlyPassword:='';
FullAccessPassword:='';
Comments:='';
Path:='';
End;
FillChar(Buf,SizeOf(Buf),#0);//  
//        ,   
//   pcTotalAvail   .
NetShareGetInfo(PChar(ComputerNetName),PChar(ResourceNetName),50,Nil,0,pcTotalAvail);
//        
GetMem(pbBuffer,pcToTalAvail);
//     ,    -     
//,     -  ,     
StrPCopy(pbBuffer^.shi50_netname,ResourceNetName);
//       
Res:=NetShareGetInfo(PChar(ComputerNetName),PChar(ResourceNetName),50,pbBuffer,pcTotalAvail,pcTotalAvail);
If Res = 0 Then //  
Begin
//     "" 
Buf:=pbBuffer^;
//   
Result.ReadOnlyPassword:=String(Buf.shi50_ro_password);
Result.FullAccessPassword:=String(Buf.shi50_rw_password);
Result.Comments:=String(Buf.shi50_remark);
Result.Path:=String(Buf.shi50_path);
End;
// 
FreeMem(pbBuffer);
End;

Procedure TForm1.FillShareEnum(Items:TStrings);
Var
ShareInfo:Array[0..MaxNetArrayItems-1] Of TShareInfo50;
EntriesRead, TotalAvial:Word;
Res:Integer;
N:Integer;
Begin
Items.Clear;// Items
FillChar(ShareInfo,SizeOf(ShareInfo),#0);//  
Res:=NetShareEnum(PChar('\\'+edComputerNetName.Text),50,@ShareInfo,SizeOf(ShareInfo),
EntriesRead,TotalAvial);//      ,
//     
If Res = No_Error Then //   
For N:=0 To EntriesRead -1 Do //     
If Not (String(ShareInfo[N].shi50_netname)='') Then
Items.Add(String(ShareInfo[N].shi50_netname));//    
End;



Function TForm1.GetComputerNetName:String;
Var
RootItemIDList:PItemIDList;//     
BrowseInfo:TBrowseInfo; //,      
Buffer:PChar; //   
Begin
Result:='';
//   PItemIDList, CSIDL_NETWORK -   
If Not(SHGetSpecialFolderLocation(0,CSIDL_NETWORK,RootItemIDList)=NO_ERROR)
Then Exit;
// ,     
GetMem(Buffer,Max_Path);
FillChar(BrowseInfo,SizeOf(BrowseInfo),0);
//  TBrowseInfo
With BrowseInfo Do
Begin {With BrowseInfo}
hwndOwner:=Application.Handle;//  -  
pidlRoot:=RootItemIDList;     //  
                              //     
pszDisplayName:=Buffer;       //     Buffer
lpszTitle:=' '; // 
ulFlags:=BIF_BROWSEFORCOMPUTER;//    
End; {With BrowseInfo}

//  
If SHBrowseForFolder(BrowseInfo)=Nil Then Exit;
Result:=String(Buffer);//  -   
FreeMem(Buffer);
end;


procedure TForm1.Button1Click(Sender: TObject);
Begin
edComputerNetName.Text:=GetComputerNetName;
FillShareEnum(ComboBox1.Items);
ComboBox1.ItemIndex:=0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
Var
ShareEvent:TShareEvent;
begin
If (edComputerNetName.Text='') Or (ComboBox1.Text='') Then
Begin
edComputerNetName.SetFocus;
Exit;
End;
ConnectAdmin;
ShareEvent:=GetShareInfo('\\'+edComputerNetName.Text,ComboBox1.Text);
edReadOnlyPassword.Text:=ShareEvent.ReadOnlyPassword;
edFullAccessPassword.Text:=ShareEvent.FullAccessPassword;
edComments.Text:=ShareEvent.Comments;
edPhysicalPath.Text:=ShareEvent.Path;
end;


procedure TForm1.BitBtn2Click(Sender: TObject);
begin
Close;
end;

end.
